varying mediump vec2 var_texcoord0;

uniform lowp sampler2D DIFFUSE_TEXTURE;
uniform lowp vec4 tint;
uniform lowp vec4 values;

// values.x = falloff
// values.y = fill %

float fillWithFalloff(vec2 uv)
{
    lowp float falloffShift = values.x * values.y;
    return min(1.0, max(0.0, (values.y - uv.x + falloffShift) / values.x));
}


void main()
{
    // Pre-multiply alpha since all runtime textures already are
    lowp float fade_alpha = fillWithFalloff(var_texcoord0.xy);
    lowp vec4 tint_pm = vec4(tint.xyz * tint.w * fade_alpha, tint.w * fade_alpha);
    gl_FragColor = texture2D(DIFFUSE_TEXTURE, var_texcoord0.xy) * tint_pm;
}
